export declare abstract class Optional<T> {
    readonly abstract isPresent: boolean;
    readonly isEmpty: boolean;
    abstract get(): T;
    abstract ifPresent(consumer: (value: T) => void): void;
    abstract filter(predicate: (value: T) => boolean): Optional<T>;
    abstract map<U>(mapper: (value: T) => U): Optional<U>;
    abstract flatMap<U>(mapper: (value: T) => Optional<U>): Optional<U>;
    abstract orElse(another: T): T;
    abstract orElseGet(another: () => T): T;
    abstract orElseThrow<U>(exception: () => U): T;
    static of<T>(value: T | null): Optional<T>;
    static ofValue<T>(value: T): Optional<T>;
    static empty<T>(): Optional<T>;
}
