"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Optional = (function () {
    function Optional() {
    }
    Object.defineProperty(Optional.prototype, "isEmpty", {
        get: function () {
            return !this.isPresent;
        },
        enumerable: true,
        configurable: true
    });
    Optional.of = function (value) {
        if (value !== null)
            return new ValueOptional(value);
        else
            return new EmptyOptional();
    };
    Optional.ofValue = function (value) {
        if (value !== null && value !== undefined)
            return new ValueOptional(value);
        else
            throw new TypeError("The passed value was null or undefined.");
    };
    Optional.empty = function () {
        return new EmptyOptional();
    };
    return Optional;
}());
exports.Optional = Optional;
var ValueOptional = (function (_super) {
    __extends(ValueOptional, _super);
    function ValueOptional(value) {
        var _this = _super.call(this) || this;
        _this.value;
        return _this;
    }
    Object.defineProperty(ValueOptional.prototype, "isPresent", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    ValueOptional.prototype.get = function () {
        return this.value;
    };
    ValueOptional.prototype.ifPresent = function (consumer) {
        consumer(this.value);
    };
    ValueOptional.prototype.filter = function (predicate) {
        return (predicate(this.value)) ? this : Optional.empty();
    };
    ValueOptional.prototype.map = function (mapper) {
        return Optional.ofValue(mapper(this.value));
    };
    ValueOptional.prototype.flatMap = function (mapper) {
        return mapper(this.value);
    };
    ValueOptional.prototype.orElse = function (another) {
        return this.value;
    };
    ValueOptional.prototype.orElseGet = function (another) {
        return this.value;
    };
    ValueOptional.prototype.orElseThrow = function (exception) {
        return this.value;
    };
    return ValueOptional;
}(Optional));
var EmptyOptional = (function (_super) {
    __extends(EmptyOptional, _super);
    function EmptyOptional() {
        return _super.call(this) || this;
    }
    Object.defineProperty(EmptyOptional.prototype, "isPresent", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    EmptyOptional.prototype.get = function () {
        throw new TypeError("The optional is not present.");
    };
    EmptyOptional.prototype.ifPresent = function (consumer) {
    };
    EmptyOptional.prototype.filter = function (predicate) {
        return this;
    };
    EmptyOptional.prototype.map = function (mapper) {
        return Optional.empty();
    };
    EmptyOptional.prototype.flatMap = function (mapper) {
        return Optional.empty();
    };
    EmptyOptional.prototype.orElse = function (another) {
        return another;
    };
    EmptyOptional.prototype.orElseGet = function (another) {
        return another();
    };
    EmptyOptional.prototype.orElseThrow = function (exception) {
        throw exception();
    };
    return EmptyOptional;
}(Optional));
